import { openBlock as l, createElementBlock as n, createElementVNode as s, toDisplayString as p, renderSlot as r, ref as w, computed as b, normalizeClass as h, unref as c, createVNode as L, withCtx as m, resolveComponent as C, createBlock as k, inject as A, withDirectives as V, isRef as B, vModelDynamic as N, createCommentVNode as v, provide as M, Fragment as x, renderList as D, vModelSelect as U, vModelText as O, useSlots as j, watch as E, normalizeStyle as Z, createTextVNode as F, onMounted as I, withKeys as G, withModifiers as z, vModelCheckbox as R } from "vue";
const H = { class: "cf-action-card" }, X = { class: "cf-action-card__body" }, J = { class: "cf-action-card__title" }, Q = { class: "cf-action-card__body__slot" }, W = { class: "cf-action-card__action" }, Wt = {
  __name: "ActionCard",
  props: {
    title: String
  },
  setup(a) {
    const e = a;
    return (t, o) => (l(), n("div", H, [
      s("div", X, [
        s("div", J, p(e.title), 1),
        s("div", Q, [
          r(t.$slots, "body")
        ])
      ]),
      s("div", W, [
        r(t.$slots, "action")
      ])
    ]));
  }
};
const T = (a, e) => {
  const t = a.__vccOpts || a;
  for (const [o, i] of e)
    t[o] = i;
  return t;
}, Y = {}, ee = { class: "cf-app-bar" };
function te(a, e) {
  return l(), n("header", ee, [
    s("div", null, [
      r(a.$slots, "left")
    ]),
    s("div", null, [
      r(a.$slots, "right")
    ])
  ]);
}
const se = /* @__PURE__ */ T(Y, [["render", te]]);
const le = { class: "cf-dropdown-body" }, oe = {
  __name: "Dropdown",
  setup(a) {
    const e = w(!1), t = b(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": e.value
    }));
    return (o, i) => (l(), n("div", {
      class: h(c(t))
    }, [
      s("div", {
        class: "cf-dropdown-toggle",
        onClick: i[0] || (i[0] = (d) => e.value = !e.value)
      }, [
        r(o.$slots, "toggle")
      ]),
      s("div", le, [
        r(o.$slots, "body")
      ]),
      s("div", {
        class: "cf-dropdown-backdrop",
        onClick: i[1] || (i[1] = (d) => e.value = !1)
      })
    ], 2));
  }
};
const ae = {
  key: 0,
  class: "cf-app-bar-link"
}, ne = { class: "cf-app-bar-link__label" }, de = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ie = {
  key: 1,
  class: "cf-app-bar-link"
}, re = { class: "cf-app-bar-link__label" }, Yt = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(a) {
    return (e, t) => a.dropdown ? (l(), n("div", ae, [
      L(oe, null, {
        toggle: m(() => [
          s("div", ne, [
            r(e.$slots, "default"),
            de
          ])
        ]),
        body: m(() => [
          r(e.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), n("button", ie, [
      s("div", re, [
        r(e.$slots, "default")
      ])
    ]));
  }
};
const es = {
  __name: "AppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": e.wide
    }));
    return (o, i) => (l(), n("div", {
      class: h(c(t))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
};
const ts = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-banner": !0,
      [`cf-banner--${e.type}`]: e.type
    }));
    return (o, i) => (l(), n("div", {
      class: h(c(t))
    }, [
      r(o.$slots, "default")
    ], 2));
  }
}, P = {
  to: {
    type: String,
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: {
    type: Boolean,
    default: !1
  },
  wide: {
    type: Boolean,
    default: !1
  },
  color: {
    type: String,
    default: null
  },
  loading: {
    type: Boolean,
    default: !1
  },
  disabled: {
    type: Boolean,
    default: !1
  }
};
const ue = ["type", "disabled"], ss = {
  __name: "FilledButton",
  props: P,
  setup(a) {
    const e = a, t = b(() => ({
      "cf-button": !0,
      "cf-button--large": e.large,
      "cf-button--wide": e.wide,
      "cf-button--loading": e.loading,
      "cf-button--disabled": e.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${e.color}`]: e.color
    }));
    return (o, i) => {
      const d = C("router-link");
      return o.to ? (l(), k(d, {
        key: 0,
        class: h(c(t)),
        to: o.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), n("button", {
        key: 1,
        class: h(c(t)),
        type: e.type,
        disabled: e.disabled
      }, [
        r(o.$slots, "default")
      ], 10, ue));
    };
  }
};
const ce = ["type", "disabled"], ls = {
  __name: "OutlinedButton",
  props: P,
  setup(a) {
    const e = a, t = b(() => ({
      "cf-button": !0,
      "cf-button--large": e.large,
      "cf-button--wide": e.wide,
      "cf-button--loading": e.loading,
      "cf-button--disabled": e.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${e.color}`]: e.color
    }));
    return (o, i) => {
      const d = C("router-link");
      return o.to ? (l(), k(d, {
        key: 0,
        class: h(c(t)),
        to: o.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), n("button", {
        key: 1,
        class: h(c(t)),
        type: e.type,
        disabled: e.disabled
      }, [
        r(o.$slots, "default")
      ], 10, ce));
    };
  }
};
const _e = ["disabled"], os = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(a) {
    const e = a;
    return (t, o) => {
      const i = C("router-link");
      return a.to ? (l(), k(i, {
        key: 0,
        class: "cf-text-button",
        to: a.to,
        inert: e.disabled
      }, {
        default: m(() => [
          r(t.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), n("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: e.disabled
      }, [
        r(t.$slots, "default")
      ], 8, _e));
    };
  }
};
const pe = { class: "cf-choice" }, fe = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], ve = ["for"], be = { key: 0 }, me = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Array],
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: String,
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = Math.random(), i = {
      name: A("choice-list-name", null),
      required: A("choice-list-required", null)
    }, d = b({
      get() {
        return t.modelValue;
      },
      set(u) {
        e("update:modelValue", u);
      }
    });
    return (u, f) => (l(), n("div", pe, [
      V(s("input", {
        "onUpdate:modelValue": f[0] || (f[0] = ($) => B(d) ? d.value = $ : null),
        type: t.type,
        id: c(o),
        name: i.name,
        value: t.value,
        "true-value": t.trueValue,
        "false-value": t.falseValue,
        required: i.required,
        disabled: t.disabled
      }, null, 8, fe), [
        [N, c(d)]
      ]),
      s("label", { for: c(o) }, p(t.label || t.value), 9, ve),
      t.helper ? (l(), n("small", be, p(t.helper), 1)) : v("", !0)
    ]));
  }
};
const ye = {
  key: 0,
  class: "cf-choice-list__label"
}, as = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": t.disabled
    })), i = b({
      get() {
        return t.modelValue;
      },
      set(d) {
        e("update:modelValue", d);
      }
    });
    return M("choice-list-name", Math.random()), M("choice-list-required", t.required), (d, u) => (l(), n("div", {
      class: h(c(o))
    }, [
      t.label ? (l(), n("div", ye, p(t.label), 1)) : v("", !0),
      (l(!0), n(x, null, D(a.choices, (f) => (l(), k(me, {
        key: f.value || f,
        type: t.multiple ? "checkbox" : "radio",
        label: f.label || f.value || f,
        helper: f.helper,
        value: f.value || f,
        disabled: t.disabled,
        modelValue: c(i),
        "onUpdate:modelValue": u[0] || (u[0] = ($) => B(i) ? i.value = $ : null)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128))
    ], 2));
  }
};
const he = { class: "cf-field" }, ge = ["required", "disabled"], $e = {
  key: 0,
  value: null
}, ke = ["value"], we = ["required", "disabled"], Se = ["type", "placeholder", "list", "required", "disabled"], Be = { key: 3 }, xe = { key: 4 }, Ce = {
  __name: "Field",
  props: {
    modelValue: [Number, String],
    type: String,
    label: String,
    placeholder: String,
    options: Array,
    list: String,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b({
      get() {
        return t.modelValue;
      },
      set(i) {
        e("update:modelValue", i);
      }
    });
    return (i, d) => (l(), n("div", he, [
      t.type === "select" ? V((l(), n("select", {
        key: 0,
        class: "cf-field__input",
        "onUpdate:modelValue": d[0] || (d[0] = (u) => B(o) ? o.value = u : null),
        required: t.required,
        disabled: t.disabled
      }, [
        t.required ? v("", !0) : (l(), n("option", $e)),
        (l(!0), n(x, null, D(t.options, (u) => (l(), n("option", {
          key: u.value || u,
          value: u.value || u
        }, p(u.label || u), 9, ke))), 128))
      ], 8, ge)), [
        [U, c(o)]
      ]) : t.type === "textarea" ? V((l(), n("textarea", {
        key: 1,
        class: "cf-field__input",
        "onUpdate:modelValue": d[1] || (d[1] = (u) => B(o) ? o.value = u : null),
        required: t.required,
        disabled: t.disabled
      }, null, 8, we)), [
        [O, c(o)]
      ]) : V((l(), n("input", {
        key: 2,
        class: "cf-field__input",
        "onUpdate:modelValue": d[2] || (d[2] = (u) => B(o) ? o.value = u : null),
        type: t.type,
        placeholder: t.placeholder,
        list: t.list,
        required: t.required,
        disabled: t.disabled
      }, null, 8, Se)), [
        [N, c(o)]
      ]),
      t.label ? (l(), n("label", Be, p(t.label), 1)) : v("", !0),
      t.helper ? (l(), n("small", xe, p(t.helper), 1)) : v("", !0)
    ]));
  }
};
const Ve = { class: "cf-data-table-item" }, De = {
  key: 0,
  class: "cf-data-table-item__drawer"
}, ze = { class: "cf-data-table-item__content" }, Le = ["data-label"], qe = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), Ae = [
  qe
], Me = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), Ne = {
  __name: "DataTableItem",
  props: {
    data: Object,
    expandable: Boolean
  },
  setup(a) {
    const e = a, t = A("columns", []), o = w(!1);
    return (i, d) => {
      const u = C("router-link");
      return l(), n("div", Ve, [
        o.value ? (l(), n("div", De, [
          r(i.$slots, "default", {
            item: e.data
          })
        ])) : v("", !0),
        s("div", ze, [
          (l(!0), n(x, null, D(c(t), (f) => (l(), n("div", {
            key: f.key,
            "data-label": f.label
          }, p(a.data[f.key]), 9, Le))), 128))
        ]),
        e.expandable ? (l(), n("button", {
          key: 1,
          class: "cf-data-table-item__toggle",
          onClick: d[0] || (d[0] = (f) => o.value = !o.value)
        }, Ae)) : v("", !0),
        e.data.to ? (l(), k(u, {
          key: 2,
          class: "cf-data-table-item__toggle",
          to: e.data.to
        }, {
          default: m(() => [
            Me
          ]),
          _: 1
        }, 8, ["to"])) : v("", !0),
        e.expandable && o.value ? (l(), n("div", {
          key: 3,
          class: "cf-data-table-item__backdrop",
          onClick: d[1] || (d[1] = (f) => o.value = !1)
        })) : v("", !0)
      ]);
    };
  }
};
const Fe = { class: "cf-data-table" }, Ie = { class: "cf-data-table__header" }, Te = { class: "cf-data-table__header__content" }, Pe = {
  key: 0,
  class: "cf-data-table__title"
}, Ke = {
  key: 1,
  class: "cf-data-table__description"
}, Ue = {
  key: 2,
  class: "cf-data-table__search"
}, Oe = {
  key: 3,
  class: "cf-data-table__actions"
}, je = {
  key: 0,
  class: "cf-data-table__header__slot"
}, Ee = { class: "cf-data-table__body__header" }, Ze = { class: "cf-data-table__body__items" }, Ge = {
  key: 0,
  class: "cf-data-table__footer"
}, Re = { class: "cf-data-table__footer__pagination" }, He = ["disabled"], Xe = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M11.022 14.503L4.518 8l6.504-6.504.707.707L5.932 8l5.797 5.796-.707.707z" })
], -1), Je = [
  Xe
], Qe = ["disabled"], We = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M4.99 14.503l-.707-.707L10.08 8 4.283 2.203l.707-.707L11.494 8 4.99 14.503z" })
], -1), Ye = [
  We
], et = { key: 0 }, ns = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    expandable: Boolean,
    paginate: {
      type: Boolean,
      default: !0
    },
    searchKey: String,
    pluralTerm: {
      type: String,
      default: "items"
    },
    itemKey: String,
    pageSize: {
      type: [Number, String],
      default: 10
    },
    columns: {
      type: Array,
      default: []
    },
    data: {
      type: Array,
      default: []
    }
  },
  setup(a) {
    const e = a, t = j(), o = w(""), i = b(() => e.data.filter((_) => {
      if (o.value) {
        const S = _[e.searchKey].replaceAll(" ", "").toLowerCase(), g = o.value.replaceAll(" ", "").toLowerCase();
        return S.includes(g);
      } else
        return !0;
    })), d = w(1), u = b(() => Math.ceil(i.value.length / parseInt(e.pageSize))), f = b(() => {
      const _ = d.value < u.value ? d.value * e.pageSize : i.value.length;
      return {
        start: (d.value - 1) * e.pageSize + 1,
        end: _
      };
    }), $ = b(() => e.paginate ? i.value.slice(
      (d.value - 1) * parseInt(e.pageSize),
      d.value * parseInt(e.pageSize)
    ) : i.value), q = () => {
      d.value < u.value && d.value++;
    }, y = () => {
      d.value > 1 && d.value--;
    };
    return E(o, () => {
      d.value > 1 && (d.value = 1);
    }), M("columns", e.columns), (_, S) => (l(), n("div", Fe, [
      s("div", Ie, [
        s("div", Te, [
          e.title ? (l(), n("div", Pe, p(e.title), 1)) : v("", !0),
          e.description ? (l(), n("div", Ke, p(e.description), 1)) : v("", !0),
          e.searchKey ? (l(), n("div", Ue, [
            L(Ce, {
              modelValue: o.value,
              "onUpdate:modelValue": S[0] || (S[0] = (g) => o.value = g),
              type: "text",
              label: "Search"
            }, null, 8, ["modelValue"])
          ])) : v("", !0),
          c(t).actions ? (l(), n("div", Oe, [
            r(_.$slots, "actions")
          ])) : v("", !0)
        ]),
        c(t).header ? (l(), n("div", je, [
          r(_.$slots, "header")
        ])) : v("", !0)
      ]),
      s("div", {
        class: "cf-data-table__body",
        style: Z(`--columns: ${e.columns.length}`)
      }, [
        s("div", Ee, [
          (l(!0), n(x, null, D(e.columns, (g) => (l(), n("div", {
            key: g.key
          }, p(g.label), 1))), 128))
        ]),
        s("div", Ze, [
          (l(!0), n(x, null, D(c($), (g) => (l(), k(Ne, {
            key: g._id || g[e.itemKey],
            data: g,
            expandable: e.expandable
          }, {
            default: m((K) => [
              r(_.$slots, "item-drawer", {
                item: K.item
              })
            ]),
            _: 2
          }, 1032, ["data", "expandable"]))), 128))
        ])
      ], 4),
      e.paginate ? (l(), n("div", Ge, [
        s("div", Re, [
          s("button", {
            disabled: d.value <= 1,
            onClick: y
          }, Je, 8, He),
          s("button", {
            disabled: d.value >= c(u),
            onClick: q
          }, Ye, 8, Qe),
          c(i).length ? (l(), n("div", et, [
            s("b", null, p(`${c(f).start} to ${c(f).end}`), 1),
            F(" of "),
            s("b", null, p(c(i).length), 1)
          ])) : v("", !0)
        ])
      ])) : v("", !0)
    ]));
  }
};
const tt = { class: "cf-sidebar-nav" }, st = /* @__PURE__ */ s("hr", null, null, -1), lt = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), ot = /* @__PURE__ */ s("span", null, "Collapse sidebar", -1), at = [
  lt,
  ot
], nt = {
  __name: "Sidebar",
  setup(a) {
    const e = w(!1), t = b(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": e.value
    }));
    return (o, i) => (l(), n("aside", {
      class: h(c(t))
    }, [
      s("nav", tt, [
        r(o.$slots, "default"),
        st
      ]),
      s("button", {
        class: "cf-sidebar-toggle",
        onClick: i[0] || (i[0] = (d) => e.value = !e.value)
      }, at)
    ], 2));
  }
};
const ds = {
  __name: "DefaultLayout",
  setup(a) {
    return I(() => {
      document.body.dataset.layout = "default";
    }), (e, t) => (l(), n(x, null, [
      L(se, null, {
        left: m(() => [
          r(e.$slots, "brand")
        ]),
        right: m(() => [
          r(e.$slots, "navigation")
        ]),
        _: 3
      }),
      L(nt, null, {
        default: m(() => [
          r(e.$slots, "sidebar")
        ]),
        _: 3
      }),
      s("main", null, [
        r(e.$slots, "main")
      ])
    ], 64));
  }
};
const dt = { class: "cf-dialog-header" }, it = { class: "cf-dialog__title" }, rt = { key: 0 }, ut = { class: "cf-dialog-body" }, ct = { class: "cf-dialog-footer" }, _t = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), pt = [
  _t
], is = {
  __name: "Dialog",
  props: {
    title: String,
    description: String
  },
  emits: ["close"],
  setup(a, { emit: e }) {
    const t = a, o = w(null);
    return I(() => o.value.showModal()), (i, d) => (l(), n("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: o,
      onKeyup: d[1] || (d[1] = G((u) => e("close"), ["delete"]))
    }, [
      s("div", dt, [
        s("div", it, p(t.title), 1),
        t.description ? (l(), n("div", rt, p(t.description), 1)) : v("", !0)
      ]),
      s("div", ut, [
        r(i.$slots, "body")
      ]),
      s("div", ct, [
        r(i.$slots, "footer")
      ]),
      s("button", {
        class: "cf-dialog-close",
        onClick: d[0] || (d[0] = (u) => e("close"))
      }, pt)
    ], 544));
  }
};
const ft = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, vt = { class: "material-symbols-outlined" }, bt = { class: "cf-dropdown-item__label" }, mt = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, yt = { class: "material-symbols-outlined" }, ht = { class: "cf-dropdown-item__label" }, rs = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(a) {
    const e = a, t = b(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": e.large
    }));
    return (o, i) => {
      const d = C("router-link");
      return a.to ? (l(), k(d, {
        key: 1,
        class: h(c(t)),
        to: a.to
      }, {
        default: m(() => [
          a.icon ? (l(), n("div", mt, [
            s("span", yt, p(a.icon), 1)
          ])) : v("", !0),
          s("div", ht, [
            r(o.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (l(), n("button", {
        key: 0,
        class: h(c(t))
      }, [
        a.icon ? (l(), n("div", ft, [
          s("span", vt, p(a.icon), 1)
        ])) : v("", !0),
        s("div", bt, [
          r(o.$slots, "default")
        ])
      ], 2));
    };
  }
};
const gt = { class: "cf-drop-zone" }, $t = ["onDrop"], kt = { class: "cf-drop-zone-box__label" }, wt = { class: "cf-drop-zone-box__action" }, St = /* @__PURE__ */ s("span", null, "select from device", -1), Bt = ["required"], xt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, Ct = {
  key: 1,
  class: "cf-drop-zone-list"
}, Vt = /* @__PURE__ */ s("div", { class: "cf-drop-zone-list__header" }, null, -1), Dt = { class: "cf-drop-zone-list__item" }, zt = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ s("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Lt = [
  zt
], us = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(a, { emit: e }) {
    const t = a, o = w(null), i = b(() => !!(t.required && !t.modelValue)), d = b(() => {
      if (t.modelValue) {
        const _ = (t.modelValue.size / 1048576).toFixed(0), S = (_ / 1e3).toFixed(1);
        return _ < 100 ? `${_} MB` : `${S} GB`;
      } else
        return "0 MB";
    }), u = (y) => {
      const _ = y.target.files[0];
      $(_);
    }, f = (y) => {
      const _ = y.dataTransfer.files[0];
      $(_);
    }, $ = (y) => {
      const _ = parseInt(t.max) * 1048576;
      _ && _ < y.size ? (o.value.value = "", alert(`File cannot exceed ${t.max} MB`)) : (e("update:modelValue", y), e("add", y));
    }, q = () => {
      e("update:modelValue", null), e("cancel");
    };
    return (y, _) => (l(), n("div", gt, [
      a.modelValue ? (l(), n("div", Ct, [
        Vt,
        s("div", Dt, [
          s("div", null, p(t.modelValue.name), 1),
          s("div", null, p(c(d)), 1),
          s("button", { onClick: q }, Lt)
        ])
      ])) : (l(), n("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: z(f, ["prevent"]),
        onDragenter: _[0] || (_[0] = z(() => {
        }, ["prevent"])),
        onDragover: _[1] || (_[1] = z(() => {
        }, ["prevent"])),
        onDragleave: _[2] || (_[2] = z(() => {
        }, ["prevent"]))
      }, [
        s("div", kt, p(t.label), 1),
        s("label", wt, [
          F(" Drag and drop or "),
          St,
          s("input", {
            type: "file",
            ref_key: "input",
            ref: o,
            required: c(i),
            onChange: u
          }, null, 40, Bt)
        ]),
        t.max ? (l(), n("div", xt, " Files larger than " + p(t.max) + " MB cannot be uploaded ", 1)) : v("", !0)
      ], 40, $t))
    ]));
  }
};
const qt = ["value", "max"], cs = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(a) {
    const e = a;
    return (t, o) => (l(), n("progress", {
      class: "cf-progress",
      value: e.value,
      max: e.max
    }, p(a.value) + "% ", 9, qt));
  }
};
const At = { class: "cf-sidebar-link__icon" }, Mt = { class: "material-symbols-outlined" }, Nt = { class: "cf-sidebar-link__label" }, Ft = ["href"], It = { class: "cf-sidebar-link__icon" }, Tt = { class: "material-symbols-outlined" }, Pt = { class: "cf-sidebar-link__label" }, _s = {
  __name: "SidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(a) {
    const e = a;
    return (t, o) => {
      const i = C("router-link");
      return a.to ? (l(), k(i, {
        key: 0,
        class: "cf-sidebar-link",
        to: e.to
      }, {
        default: m(() => [
          s("div", At, [
            s("span", Mt, p(a.icon), 1)
          ]),
          s("div", Nt, [
            r(t.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (l(), n("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: a.href
      }, [
        s("div", It, [
          s("span", Tt, p(a.icon), 1)
        ]),
        s("div", Pt, [
          r(t.$slots, "default")
        ])
      ], 8, Ft));
    };
  }
};
const Kt = {}, Ut = { class: "cf-spinner" }, Ot = /* @__PURE__ */ s("div", null, null, -1), jt = /* @__PURE__ */ s("div", null, null, -1), Et = /* @__PURE__ */ s("div", null, null, -1), Zt = /* @__PURE__ */ s("div", null, null, -1), Gt = [
  Ot,
  jt,
  Et,
  Zt
];
function Rt(a, e) {
  return l(), n("div", Ut, Gt);
}
const ps = /* @__PURE__ */ T(Kt, [["render", Rt]]);
const Ht = { class: "cf-switch" }, Xt = ["value", "true-value", "false-value", "disabled"], Jt = {
  key: 0,
  class: "cf-switch__label"
}, fs = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(a, { emit: e }) {
    const t = a, o = b({
      get() {
        return t.modelValue;
      },
      set(i) {
        e("update:modelValue", i);
      }
    });
    return (i, d) => (l(), n("div", Ht, [
      V(s("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": d[0] || (d[0] = (u) => B(o) ? o.value = u : null),
        type: "checkbox",
        value: t.value,
        "true-value": t.trueValue,
        "false-value": t.falseValue,
        disabled: t.disabled
      }, null, 8, Xt), [
        [R, c(o)]
      ]),
      t.label ? (l(), n("div", Jt, p(t.label), 1)) : v("", !0)
    ]));
  }
};
export {
  Wt as CfActionCard,
  se as CfAppBar,
  Yt as CfAppBarLink,
  es as CfAppBody,
  ts as CfBanner,
  me as CfChoice,
  as as CfChoiceList,
  ns as CfDataTable,
  ds as CfDefaultLayout,
  is as CfDialog,
  us as CfDropZone,
  oe as CfDropdown,
  rs as CfDropdownItem,
  Ce as CfField,
  ss as CfFilledButton,
  ls as CfOutlinedButton,
  cs as CfProgress,
  nt as CfSidebar,
  _s as CfSidebarLink,
  ps as CfSpinner,
  fs as CfSwitch,
  os as CfTextButton
};
